//dieser Quelltext ist nicht von der Gruppe Schrottbot sondern von Felix
//der Quelltext wurde lediglich für unsere Zwecke leicht angepasst



#pragma once
/*
   Measure Times using AVR Timer1 Input Capture

   Timer One counts CPU-Cycles.
   After enabling "Input Capture", it will save the current cycle count in the ICR1 Register whenever a Rising/Falling Signal flank is detected on pin 8
   This will break the servo library

*/

#include "Arduino.h"

// some bit-masking shortcuts
#define sbi(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define cbi(ADDRESS,BIT) ((ADDRESS) &= ~(1<<(BIT)))
#define outp(VAL,ADRESS) ((ADRESS) = (VAL))
#define inp(VAL) (VAL)

unsigned long measrePulseByICP() {
  int n = 5;                                                                                                                 //maximale anzahl an messungen
  noInterrupts(); // we don't want to be disturbed                                                                            Präampel
  // prepare timer 1 for input capture
  TCCR1A = 0 ;
  TCCR1B = (1 << ICNC1) +   // Normal counting mode
           (1 << CS10) +    // set prescaler to 1
           (1 << ICES1);    // trigger on rising edge
  TIMSK1 = 0;               // disable all Timer1 related interrupts
  TIFR1 =  (1 << TOV1) + (1 << ICF1); // clear the interrupt pending flags. Bizarre: The interrupt pending flags are set to ZERO by writing ONE to it (!!!)
  TCNT1 = 0;     // reset the timer counter so we start counting at zero
  unsigned int zeitamanfang = 0;                                                                                               //anzahl an CPU_cycelm am anfang der messung
  unsigned int zeitamende = 0;                                                                                                 //anzahl der CPU-cyclen am ende der messung


  unsigned int timerOverFlowCount = 0; // number of overflows since the pulse has started                                       deklarierte Variablen

  // here we could do anything that we need to create that pulse...


  register uint8_t tifrCached = TIFR1;    // read all flags at once to prevent race conditions

  // now we wait for the voltage at the pin to rise and count timer overflows while we do so.                                 wartet auf rising edge flag
  //digitalWrite(4, HIGH);
  while (!(tifrCached & (1 << ICF1))) {// repeat while input capture edge detect flag is not set
    if (tifrCached & (1 << TOV1)) {  // check if the timer overflow bit is set
      TIFR1 =  (1 << TOV1);          // clear overflow flag
    }
    tifrCached = TIFR1;               // read all flags at once to prevent race conditions
  }
  TIFR1 =  (1 << ICIE1);  // clear input edge detect flag
  zeitamanfang = ICR1;   // remember the timer value when the pin changed to HIGH                                           schreib CPU-Zählerstand
  // digitalWrite(4, LOW);
  for (int i = 0; i < n; i++) {                                                                                            //wiederholt die messung der nulldurchgänge 10 mal
    tifrCached = TIFR1;               // read all flags at once to prevent race conditions
    while (!(tifrCached & (1 << ICF1))) {// repeat while input capture edge detect flag is not set
      if (tifrCached & (1 << TOV1)) {  // check if the timer overflow bit is set
        timerOverFlowCount++;           // count timer overflows...
        TIFR1 =  (1 << TOV1);          // clear overflow flag
      }
      tifrCached = TIFR1;               // read all flags at once to prevent race conditions

    }
    TIFR1 =  (1 << ICIE1);  // clear input edge detect flag
  }
  zeitamende = ICR1;


  interrupts();                        // let the rest of the µC do it's work again...

  // now we can calculate the amount of CPU-cylces between rising and falling edge...
  // due to unsigned int arithmetics, we can just substract timer values regardless of overflows and add a bitshiftet overflow count.
  unsigned long pulseCycles = (unsigned long)(zeitamende - zeitamanfang) | (unsigned long)timerOverFlowCount << 16; // combine the number of overflows with the timer value when the flanc was detected.
  // Serial.println(timerOverFlowCount);
  // Serial.println(zeitamende);
  // Serial.println(zeitamanfang);
  // Serial.println(pulseCycles);
  return pulseCycles;
}


